import {
  useLimeplay
} from "./chunk-Y3E2TR35.mjs";

// src/hooks/useShakaPlayer.ts
import { useEffect, useState } from "react";
import shaka from "shaka-player";
function useShakaPlayer() {
  const { playbackRef, playerRef } = useLimeplay();
  const [error, setError] = useState(null);
  const [isLoaded, setIsLoaded] = useState(false);
  useEffect(() => {
    var _a;
    const errorHandler = (event) => {
      if (event instanceof Event)
        return;
      setError(event);
    };
    console.log("playbackRef.current");
    console.log(playbackRef.current);
    console.log("playerRef.current");
    console.log(playerRef.current);
    console.log("playerRef.current.getLoadMode()");
    console.log((_a = playerRef.current) == null ? void 0 : _a.getLoadMode());
    if (playbackRef.current) {
      const _player = new shaka.Player(playbackRef.current);
      playerRef.current = _player;
      _player.addEventListener("error", errorHandler);
      setIsLoaded(true);
    }
    return () => {
      setIsLoaded(false);
      setError(null);
      console.log("useShakaPlayer unmounted");
      if (playbackRef.current) {
        const _player = playerRef.current;
        _player.removeEventListener("error", errorHandler);
        _player.destroy();
        playbackRef.current = null;
      }
    };
  }, []);
  return {
    playerRef,
    playbackRef,
    error,
    isLoaded
  };
}

export {
  useShakaPlayer
};
